Index: palm/trunk/SOURCE/user_read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/user_read_restart_data_mod.f90	(revision 2894)
+++ palm/trunk/SOURCE/user_read_restart_data_mod.f90	(revision 2894)
@@ -0,0 +1,165 @@
+!> @file user_read_restart_data_mod.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+!
+! Description:
+! ------------
+!> Reads user specific restart data into binary file(s) for restart runs.
+!------------------------------------------------------------------------------!
+ MODULE user_read_restart_data_mod
+
+
+    USE user
+     
+
+    IMPLICIT NONE
+
+
+    INTERFACE user_rrd_global
+       MODULE PROCEDURE user_rrd_global
+    END INTERFACE user_rrd_global
+
+    INTERFACE user_rrd_local
+       MODULE PROCEDURE user_rrd_local
+    END INTERFACE user_rrd_local
+
+
+    PUBLIC user_rrd_global, user_rrd_local
+
+
+ CONTAINS
+
+
+!-------------
+! Description:
+! ------------
+!> Reading global restart data that has been defined by the user.
+!------------------------------------------------------------------------------!
+    SUBROUTINE user_rrd_global( found )
+
+
+       USE control_parameters,                                                 &
+           ONLY: length, restart_string
+
+
+       IMPLICIT NONE
+
+       LOGICAL, INTENT(OUT)  ::  found 
+
+
+       found = .TRUE.
+
+
+       SELECT CASE ( restart_string(1:length) )
+
+          CASE ( 'global_paramter' )
+!             READ ( 13 )  global_parameter
+
+          CASE DEFAULT
+ 
+             found = .FALSE.
+
+       END SELECT  
+
+
+    END SUBROUTINE user_rrd_global
+
+
+! Description:
+! ------------
+!> Reading processor specific restart data from file(s) that has been defined 
+!> by the user.
+!> Subdomain index limits on file are given by nxl_on_file, etc.
+!> Indices nxlc, etc. indicate the range of gridpoints to be mapped from the
+!> subdomain on file (f) to the subdomain of the current PE (c). They have been
+!> calculated in routine rrd_local.
+!------------------------------------------------------------------------------!
+    SUBROUTINE user_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,      &
+                               nxr_on_file, nynf, nync, nyn_on_file, nysf,     & 
+                               nysc, nys_on_file, tmp_3d, found )
+    
+
+       USE control_parameters
+           
+       USE indices
+       
+       USE kinds
+       
+       USE pegrid
+ 
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i               !< 
+       INTEGER(iwp) ::  k               !< 
+       INTEGER(iwp) ::  nxlc            !< 
+       INTEGER(iwp) ::  nxlf            !< 
+       INTEGER(iwp) ::  nxl_on_file     !< 
+       INTEGER(iwp) ::  nxrc            !< 
+       INTEGER(iwp) ::  nxrf            !< 
+       INTEGER(iwp) ::  nxr_on_file     !< 
+       INTEGER(iwp) ::  nync            !< 
+       INTEGER(iwp) ::  nynf            !< 
+       INTEGER(iwp) ::  nyn_on_file     !< 
+       INTEGER(iwp) ::  nysc            !< 
+       INTEGER(iwp) ::  nysf            !< 
+       INTEGER(iwp) ::  nys_on_file     !< 
+
+       LOGICAL, INTENT(OUT)  ::  found 
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !< 
+
+!
+!-- Here the reading of user-defined restart data follows:
+!-- Sample for user-defined output
+
+
+       found = .TRUE.
+
+
+          SELECT CASE ( restart_string(1:length) )
+
+             CASE ( 'u2_av' )
+!                IF ( .NOT. ALLOCATED( u2_av ) ) THEN
+!                     ALLOCATE( u2_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!                ENDIF
+!                IF ( k == 1 )  READ ( 13 )  tmp_3d
+!                   u2_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =         &
+!                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+!
+             CASE DEFAULT
+
+                found = .FALSE.
+
+             END SELECT
+
+
+    END SUBROUTINE user_rrd_local
+
+
+ END MODULE user_read_restart_data_mod
Index: palm/trunk/SOURCE/user_write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/user_write_restart_data_mod.f90	(revision 2894)
+++ palm/trunk/SOURCE/user_write_restart_data_mod.f90	(revision 2894)
@@ -0,0 +1,101 @@
+!> @file user_write_restart_data_mod.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+! 
+!
+! Description:
+! ------------
+!> Writes user specific restart data into binary file(s) for restart runs.
+!------------------------------------------------------------------------------!
+ MODULE user_write_restart_data_mod
+
+
+    USE user
+     
+
+    IMPLICIT NONE
+
+
+    INTERFACE user_wrd_global
+       MODULE PROCEDURE user_wrd_global
+    END INTERFACE user_wrd_global
+
+    INTERFACE user_wrd_local
+       MODULE PROCEDURE user_wrd_local
+    END INTERFACE user_wrd_local
+
+
+    PUBLIC user_wrd_global, user_wrd_local
+
+
+ CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Writes global and user-defined restart data into binary file(s) for restart
+!> runs.
+!------------------------------------------------------------------------------!
+    SUBROUTINE user_wrd_global  
+
+
+       IMPLICIT NONE
+
+       
+!       CALL wrd_write_string( 'global_parameter' )
+!       WRITE ( 14 )  global_parameter
+
+       
+    END SUBROUTINE user_wrd_global    
+
+
+! Description:
+! ------------
+!> Writes processor specific and user-defined restart data into binary file(s) 
+!> for restart runs.
+!------------------------------------------------------------------------------!
+    SUBROUTINE user_wrd_local
+
+
+       IMPLICIT NONE
+
+
+!
+!-- Here the user-defined actions at the end of a job follow.
+!-- Sample for user-defined output:
+!          IF ( ALLOCATED( u2_av ) )  THEN
+!             CALL wrd_write_string( 'u2_av' )  
+!             WRITE ( 14 )  u2_av
+!          ENDIF
+
+
+
+    END SUBROUTINE user_wrd_local
+
+
+ END MODULE user_write_restart_data_mod
Index: palm/trunk/SOURCE/uv_exposure_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/uv_exposure_model_mod.f90	(revision 2894)
@@ -25,4 +25,14 @@
 ! -----------------
 ! $Id$
+! Routine for skipping global restart data has been removed, uvem_last_actions
+! has been renamed to uvem_wrd_global and uvem_read_restart_data has been 
+! renamed to uvem_rrd_global, variable named found has been introduced for 
+! checking if restart data was found, reading of restart strings has been moved
+! completely to read_restart_data_mod, marker *** end new module *** has been
+! removed, strings and their respective lengths are written out and read now 
+! in case of restart runs to get rid of prescribed character lengths, CASE 
+! DEFAULT was added if restart data is read 
+! 
+! 2848 2018-03-05 10:11:18Z Giersch
 ! Initial revision
 !
@@ -199,7 +209,7 @@
 ! !
 ! !-- Writing of binary output for restart runs  !!! renaming?!
-!     INTERFACE uvem_last_actions
-!        MODULE PROCEDURE uvem_last_actions
-!     END INTERFACE uvem_last_actions
+!     INTERFACE uvem_wrd_global
+!        MODULE PROCEDURE uvem_wrd_global
+!     END INTERFACE uvem_wrd_global
 !     
 !
@@ -211,13 +221,7 @@
 ! !
 ! !-- Reading of parameters for restart runs
-!     INTERFACE uvem_read_restart_data
-!        MODULE PROCEDURE uvem_read_restart_data
-!     END INTERFACE uvem_read_restart_data
-! 
-! !
-! !-- Writing of parameters for restart runs !!! renaming?!
-!     INTERFACE uvem_skip_var_list
-!        MODULE PROCEDURE uvem_skip_var_list
-!     END INTERFACE uvem_skip_var_list
+!     INTERFACE uvem_rrd_global
+!        MODULE PROCEDURE uvem_rrd_global
+!     END INTERFACE uvem_rrd_global
 ! 
 ! !
@@ -860,30 +864,33 @@
 ! ! Description:
 ! ! ------------
-! !> This routine reads the respective restart data.
+! !> This routine reads the global restart data.
 ! !------------------------------------------------------------------------------!
-!  SUBROUTINE uvem_read_restart_data  
-! 
-!     
+!  SUBROUTINE uvem_rrd_global
+!
+!
+!     USE control_parameters,                                                    &
+!         ONLY: length, restart_string
+!
+!
 !     IMPLICIT NONE
-!        
-!     CHARACTER (LEN=30) ::  variable_chr  !< dummy variable to read string
+!
+!     LOGICAL, INTENT(OUT)  ::  found 
+!
+!
+!     found = .TRUE. 
 !        
 !        
-!     READ ( 13 )  variable_chr
-!     DO  WHILE ( TRIM( variable_chr ) /= '*** end new module ***' )
-! 
-!        SELECT CASE ( TRIM( variable_chr ) )
-!           
-! !           CASE ( 'param1' )
-! !              IF ( .NOT. ALLOCATED( param1 ) )  ALLOCATE( param1(...) )
-! !              READ ( 13 )  param1   
-!           
-!        END SELECT
-!           
-!        READ ( 13 )  variable_chr
-!           
-!     ENDDO
-! 
-!  END SUBROUTINE uvem_read_restart_data  
+!     SELECT CASE ( restart_string(1:length) )
+!
+!       CASE ( 'param1' )
+!          READ ( 13 )  param1
+!
+!        CASE DEFAULT
+!
+!          found = .FALSE.   
+!
+!     END SELECT
+! 
+!  END SUBROUTINE uvem_rrd_global  
     
 
@@ -891,37 +898,18 @@
 ! ! Description:
 ! ! ------------
-! !> This routine writes the respective restart data.
+! !> This routine writes the global restart data.
 ! !------------------------------------------------------------------------------!
-!  SUBROUTINE uvem_last_actions
-! 
+!  SUBROUTINE uvem_wrd_global
+! 
+!
 !     IMPLICIT NONE
+!
+!
+!     CALL wrd_write_string( 'param1' )
+!     WRITE ( 14 )  param1         
+! 
 !        
-! !      WRITE ( 14 )  'param1                            '
-! !      WRITE ( 14 )  param1       
-! 
 !        
-!     WRITE ( 14 )  '*** end new module ***            '
-!        
-!  END SUBROUTINE uvem_last_actions   
-
-
-! !------------------------------------------------------------------------------!
-! ! Description:
-! ! ------------
-! !> Skipping of parameters from restart file (binary format).
-! !------------------------------------------------------------------------------!
-!  SUBROUTINE uvem_skip_var_list  
-!            
-!     IMPLICIT NONE
-!        
-!     CHARACTER (LEN=1)  ::  param2         !<
-!     CHARACTER (LEN=30) ::  variable_chr   !<
-!        
-!     READ ( 13 )  variable_chr
-!     DO  WHILE ( TRIM( variable_chr ) /= '*** end new module ***' )
-!        READ ( 13 )  param2
-!     ENDDO    
-!        
-!  END SUBROUTINE uvem_skip_var_list 
+!  END SUBROUTINE uvem_wrd_global   
 
 
Index: palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 2894)
@@ -25,4 +25,15 @@
 ! -----------------
 ! $Id$
+! variable named found has been introduced for checking if restart data was 
+! found, reading of restart strings has been moved completely to 
+! read_restart_data_mod, virtual_flight_prerun flag has been removed, redundant
+! skipping function has been removed, flight_read/write_restart_data 
+! have been renamed to flight_r/wrd_global, flight_rrd_global is called in 
+! read_restart_data_mod now, marker *** end flight *** was removed, strings and
+! their respective lengths are written out and read now in case of restart runs
+! to get rid of prescribed character lengths, CASE DEFAULT was added if restart
+! data is read
+! 
+! 2872 2018-03-12 10:05:47Z Giersch
 ! virutal_flight_prerun flag is used to define if module 
 ! related parameters were outputted as restart data
@@ -66,6 +77,5 @@
  
     USE control_parameters,                                                    &
-        ONLY:  fl_max, num_leg, num_var_fl, num_var_fl_user, virtual_flight,   &
-               virtual_flight_prerun
+        ONLY:  fl_max, num_leg, num_var_fl, num_var_fl_user, virtual_flight
  
     USE kinds
@@ -134,16 +144,12 @@
        MODULE PROCEDURE flight_measurement
     END INTERFACE flight_measurement
-
-    INTERFACE flight_skip_var_list 
-       MODULE PROCEDURE flight_skip_var_list
-    END INTERFACE flight_skip_var_list
-    
-    INTERFACE flight_read_restart_data 
-       MODULE PROCEDURE flight_read_restart_data
-    END INTERFACE flight_read_restart_data
-    
-    INTERFACE flight_write_restart_data 
-       MODULE PROCEDURE flight_write_restart_data 
-    END INTERFACE flight_write_restart_data 
+    
+    INTERFACE flight_rrd_global 
+       MODULE PROCEDURE flight_rrd_global
+    END INTERFACE flight_rrd_global
+    
+    INTERFACE flight_wrd_global 
+       MODULE PROCEDURE flight_wrd_global 
+    END INTERFACE flight_wrd_global 
 
 !
@@ -153,5 +159,5 @@
 !-- Public interfaces
     PUBLIC flight_init, flight_header, flight_parin, flight_measurement,       &
-           flight_write_restart_data, flight_skip_var_list                    
+           flight_wrd_global, flight_rrd_global                   
 !
 !-- Public variables
@@ -238,7 +244,4 @@
        virtual_flight = .TRUE.
 
-       IF ( TRIM( initializing_actions ) == 'read_restart_data' ) THEN
-          CALL flight_read_restart_data
-       ENDIF
 
  10    CONTINUE
@@ -879,29 +882,6 @@
 
     END SUBROUTINE flight_check_parameters
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Skipping the flight-module variables from restart-file (binary format).
-!------------------------------------------------------------------------------!
-   SUBROUTINE flight_skip_var_list 
         
-      IMPLICIT NONE
-            
-      CHARACTER (LEN=1)  ::  cdum
-      CHARACTER (LEN=30) ::  variable_chr
-            
-      READ ( 13 )  variable_chr
-
-      DO  WHILE ( TRIM( variable_chr ) /= '*** end flight ***' )
-
-         READ ( 13 )  cdum
-         READ ( 13 )  variable_chr
-
-      ENDDO   
-            
-   END SUBROUTINE flight_skip_var_list 
-        
-   
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -909,45 +889,48 @@
 !> This routine reads the respective restart data.
 !------------------------------------------------------------------------------!
-    SUBROUTINE flight_read_restart_data  
+    SUBROUTINE flight_rrd_global( found )  
+
+
+       USE control_parameters,                                                 &
+           ONLY: length, restart_string
 
     
        IMPLICIT NONE
        
-       CHARACTER (LEN=30) ::  variable_chr !< dummy variable to read string
-       
-       
-       READ ( 13 )  variable_chr
-       DO  WHILE ( TRIM( variable_chr ) /= '*** end flight ***' )
-
-          SELECT CASE ( TRIM( variable_chr ) )
+       LOGICAL, INTENT(OUT)  ::  found 
+
+
+       found = .TRUE.
+
+
+       SELECT CASE ( restart_string(1:length) )
           
-             CASE ( 'u_agl' )
-                IF ( .NOT. ALLOCATED( u_agl ) )  ALLOCATE( u_agl(1:num_leg) )
-                READ ( 13 )  u_agl   
-             CASE ( 'v_agl' )
-                IF ( .NOT. ALLOCATED( v_agl ) )  ALLOCATE( v_agl(1:num_leg) )
-                READ ( 13 )  v_agl
-             CASE ( 'w_agl' )
-                IF ( .NOT. ALLOCATED( w_agl ) )  ALLOCATE( w_agl(1:num_leg) )
-                READ ( 13 )  w_agl
-             CASE ( 'x_pos' )
-                IF ( .NOT. ALLOCATED( x_pos ) )  ALLOCATE( x_pos(1:num_leg) )
-                READ ( 13 )  x_pos
-             CASE ( 'y_pos' )
-                IF ( .NOT. ALLOCATED( y_pos ) )  ALLOCATE( y_pos(1:num_leg) )
-                READ ( 13 )  y_pos
-             CASE ( 'z_pos' )
-                IF ( .NOT. ALLOCATED( z_pos ) )  ALLOCATE( z_pos(1:num_leg) )
-                READ ( 13 )  z_pos
-             CASE ( 'virtual_flight_prerun' )
-                READ ( 13 )  virtual_flight_prerun
+          CASE ( 'u_agl' )
+             IF ( .NOT. ALLOCATED( u_agl ) )  ALLOCATE( u_agl(1:num_leg) )
+             READ ( 13 )  u_agl   
+          CASE ( 'v_agl' )
+             IF ( .NOT. ALLOCATED( v_agl ) )  ALLOCATE( v_agl(1:num_leg) )
+             READ ( 13 )  v_agl
+          CASE ( 'w_agl' )
+             IF ( .NOT. ALLOCATED( w_agl ) )  ALLOCATE( w_agl(1:num_leg) )
+             READ ( 13 )  w_agl
+          CASE ( 'x_pos' )
+             IF ( .NOT. ALLOCATED( x_pos ) )  ALLOCATE( x_pos(1:num_leg) )
+             READ ( 13 )  x_pos
+          CASE ( 'y_pos' )
+             IF ( .NOT. ALLOCATED( y_pos ) )  ALLOCATE( y_pos(1:num_leg) )
+             READ ( 13 )  y_pos
+          CASE ( 'z_pos' )
+             IF ( .NOT. ALLOCATED( z_pos ) )  ALLOCATE( z_pos(1:num_leg) )
+             READ ( 13 )  z_pos
+
+          CASE DEFAULT
+
+             found = .FALSE.
           
-          END SELECT
-          
-          READ ( 13 )  variable_chr
-          
-       ENDDO
-
-    END SUBROUTINE flight_read_restart_data  
+       END SELECT
+
+
+    END SUBROUTINE flight_rrd_global  
     
 !------------------------------------------------------------------------------!
@@ -956,28 +939,30 @@
 !> This routine writes the respective restart data.
 !------------------------------------------------------------------------------!
-    SUBROUTINE flight_write_restart_data  
+    SUBROUTINE flight_wrd_global  
+
 
        IMPLICIT NONE
 
-       virtual_flight_prerun = .TRUE.
-       
-       WRITE ( 14 )  'u_agl                         '
-       WRITE ( 14 )  u_agl       
-       WRITE ( 14 )  'v_agl                         '
+ 
+       CALL wrd_write_string( 'u_agl' )
+       WRITE ( 14 )  u_agl
+
+       CALL wrd_write_string( 'v_agl' )
        WRITE ( 14 )  v_agl
-       WRITE ( 14 )  'w_agl                         '
+
+       CALL wrd_write_string( 'w_agl' )
        WRITE ( 14 )  w_agl
-       WRITE ( 14 )  'x_pos                         '
+
+       CALL wrd_write_string( 'x_pos' )
        WRITE ( 14 )  x_pos
-       WRITE ( 14 )  'y_pos                         '
+
+       CALL wrd_write_string( 'y_pos' )
        WRITE ( 14 )  y_pos
-       WRITE ( 14 )  'z_pos                         '
+
+       CALL wrd_write_string( 'z_pos' )
        WRITE ( 14 )  z_pos
-       WRITE ( 14 )  'virtual_flight_prerun         '
-       WRITE ( 14 )  virtual_flight_prerun
-       
-       WRITE ( 14 )  '*** end flight ***            '
-       
-    END SUBROUTINE flight_write_restart_data    
+
+       
+    END SUBROUTINE flight_wrd_global    
     
 
Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 2894)
@@ -26,4 +26,15 @@
 ! -----------------
 ! $Id$
+! variable named found has been introduced for checking if restart data was 
+! found, reading of restart strings has been moved completely to 
+! read_restart_data_mod, wind_turbine_prerun flag has been removed, redundant 
+! skipping function has been removed, wtm_read/write_restart_data have been
+! renamed to wtm_r/wrd_global, wtm_rrd_global is called in 
+! read_restart_data_mod now, marker *** end wtm *** was removed, strings and 
+! their respective lengths are written out and read now in case of restart 
+! runs to get rid of prescribed character lengths, CASE DEFAULT was added if 
+! restart data is read 
+! 
+! 2885 2018-03-14 11:02:46Z Giersch
 ! Bugfix in interpolation of lift and drag coefficients on fine grid of radius 
 ! segments and angles of attack, speed-up of the initialization of the wind 
@@ -49,5 +60,5 @@
 !
 ! 2576 2017-10-24 13:49:46Z Giersch
-! Definition of a new function called wtm_skip_var_list to skip module 
+! Definition of a new function called wtm_skip_global to skip module 
 ! parameters during reading restart data
 ! 
@@ -137,5 +148,5 @@
     USE control_parameters,                                                    &
         ONLY:  coupling_char, dt_3d, dz, message_string, simulated_time,       &
-               wind_turbine, wind_turbine_prerun, initializing_actions
+               wind_turbine, initializing_actions
 
     USE cpulog,                                                                &
@@ -404,15 +415,11 @@
     END INTERFACE wtm_parin
 
-    INTERFACE wtm_skip_var_list 
-       MODULE PROCEDURE wtm_skip_var_list 
-    END INTERFACE wtm_skip_var_list
-
-    INTERFACE wtm_write_restart_data 
-       MODULE PROCEDURE wtm_write_restart_data 
-    END INTERFACE wtm_write_restart_data
-
-    INTERFACE wtm_read_restart_data 
-       MODULE PROCEDURE wtm_read_restart_data
-    END INTERFACE wtm_read_restart_data 
+    INTERFACE wtm_wrd_global 
+       MODULE PROCEDURE wtm_wrd_global 
+    END INTERFACE wtm_wrd_global
+
+    INTERFACE wtm_rrd_global 
+       MODULE PROCEDURE wtm_rrd_global
+    END INTERFACE wtm_rrd_global 
     
     INTERFACE wtm_check_parameters
@@ -456,5 +463,5 @@
     
     PUBLIC wtm_check_parameters, wtm_forces, wtm_init, wtm_init_arrays,        &
-           wtm_parin, wtm_write_restart_data, wtm_tendencies, wtm_skip_var_list
+           wtm_parin, wtm_wrd_global, wtm_rrd_global, wtm_tendencies
 
 
@@ -514,7 +521,4 @@
        wind_turbine = .TRUE.
 
-       IF ( TRIM( initializing_actions ) == 'read_restart_data' ) THEN
-          CALL wtm_read_restart_data
-       ENDIF
 
  10    CONTINUE   ! TBD Change from continue, mit ierrn machen
@@ -522,28 +526,4 @@
 
     END SUBROUTINE wtm_parin
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Skipping the wind turbine module variables from restart-file (binary format).
-!------------------------------------------------------------------------------!
-   SUBROUTINE wtm_skip_var_list 
-        
-      IMPLICIT NONE
-            
-      CHARACTER (LEN=1)  ::  cdum
-      CHARACTER (LEN=30) ::  variable_chr
-            
-      READ ( 13 )  variable_chr
-
-      DO  WHILE ( TRIM( variable_chr ) /= '*** end wtm ***' )
-
-         READ ( 13 )  cdum
-         READ ( 13 )  variable_chr
-
-      ENDDO   
-            
-   END SUBROUTINE wtm_skip_var_list 
 
 
@@ -553,36 +533,42 @@
 !> This routine writes the respective restart data.
 !------------------------------------------------------------------------------!
-    SUBROUTINE wtm_write_restart_data  
+    SUBROUTINE wtm_wrd_global  
+
 
        IMPLICIT NONE
 
-       wind_turbine_prerun = .TRUE.
-       
-       WRITE ( 14 )  'omega_gen                     '
+       
+       CALL wrd_write_string( 'omega_gen' )
        WRITE ( 14 )  omega_gen
-       WRITE ( 14 )  'omega_gen_f                   '
+
+       CALL wrd_write_string( 'omega_gen_f' )
        WRITE ( 14 )  omega_gen_f
-       WRITE ( 14 )  'omega_gen_f_old               '
+
+       CALL wrd_write_string( 'omega_gen_f_old' )
        WRITE ( 14 )  omega_gen_f_old
-       WRITE ( 14 )  'omega_gen_old                 '
+
+       CALL wrd_write_string( 'omega_gen_old' )
        WRITE ( 14 )  omega_gen_old
-       WRITE ( 14 )  'omega_rot                     '
+
+       CALL wrd_write_string( 'omega_rot' )
        WRITE ( 14 )  omega_rot
-       WRITE ( 14 )  'phi_yaw                       '
-       WRITE ( 14 )  phi_yaw(:)
-       WRITE ( 14 )  'pitch_add                     '
+
+       CALL wrd_write_string( 'phi_yaw' )
+       WRITE ( 14 )  phi_yaw
+
+       CALL wrd_write_string( 'pitch_add' )
        WRITE ( 14 )  pitch_add
-       WRITE ( 14 )  'pitch_add_old                 '
+
+       CALL wrd_write_string( 'pitch_add_old' )
        WRITE ( 14 )  pitch_add_old
-       WRITE ( 14 )  'torque_gen                    '
+
+       CALL wrd_write_string( 'torque_gen' )
        WRITE ( 14 )  torque_gen
-       WRITE ( 14 )  'torque_gen_old                '
+
+       CALL wrd_write_string( 'torque_gen_old' )
        WRITE ( 14 )  torque_gen_old
-       WRITE ( 14 )  'wind_turbine_prerun           '
-       WRITE ( 14 )  wind_turbine_prerun
-     
-       WRITE ( 14 )  '*** end wtm ***               '
-       
-    END SUBROUTINE wtm_write_restart_data    
+
+       
+    END SUBROUTINE wtm_wrd_global    
 
 
@@ -592,47 +578,50 @@
 !> This routine reads the respective restart data.
 !------------------------------------------------------------------------------!
- SUBROUTINE wtm_read_restart_data
+ SUBROUTINE wtm_rrd_global( found )
+
+
+    USE control_parameters,                                                    &
+        ONLY: length, restart_string
 
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=30) ::  variable_chr  !< dummy variable to read string
-
-
-    READ ( 13 )  variable_chr
-    DO  WHILE ( TRIM( variable_chr ) /= '*** end wtm ***' )
-
-       SELECT CASE ( TRIM( variable_chr ) )
-
-          CASE ( 'omega_gen' )
-             READ ( 13 )  omega_gen
-          CASE ( 'omega_gen_f' )
-             READ ( 13 )  omega_gen_f
-          CASE ( 'omega_gen_f_old' )
-             READ ( 13 )  omega_gen_f_old
-          CASE ( 'omega_gen_old' )
-             READ ( 13 )  omega_gen_old
-          CASE ( 'omega_rot' )
-             READ ( 13 )  omega_rot
-          CASE ( 'phi_yaw' )
-             READ ( 13 )  phi_yaw
-          CASE ( 'pitch_add' )
-             READ ( 13 )  pitch_add
-          CASE ( 'pitch_add_old' )
-             READ ( 13 )  pitch_add_old
-          CASE ( 'torque_gen' )
-             READ ( 13 )  torque_gen
-          CASE ( 'torque_gen_old' )
-             READ ( 13 )  torque_gen_old
-          CASE ( 'wind_turbine_prerun' )
-             READ ( 13 )  wind_turbine_prerun
-
-       END SELECT
-       
-       READ ( 13 )  variable_chr
-
-    ENDDO
-
- END SUBROUTINE wtm_read_restart_data
+    LOGICAL, INTENT(OUT)  ::  found 
+
+
+    found = .TRUE.
+
+
+    SELECT CASE ( restart_string(1:length) )
+
+       CASE ( 'omega_gen' )
+          READ ( 13 )  omega_gen
+       CASE ( 'omega_gen_f' )
+          READ ( 13 )  omega_gen_f
+       CASE ( 'omega_gen_f_old' )
+          READ ( 13 )  omega_gen_f_old
+       CASE ( 'omega_gen_old' )
+          READ ( 13 )  omega_gen_old
+       CASE ( 'omega_rot' )
+          READ ( 13 )  omega_rot
+       CASE ( 'phi_yaw' )
+          READ ( 13 )  phi_yaw
+       CASE ( 'pitch_add' )
+          READ ( 13 )  pitch_add
+       CASE ( 'pitch_add_old' )
+          READ ( 13 )  pitch_add_old
+       CASE ( 'torque_gen' )
+          READ ( 13 )  torque_gen
+       CASE ( 'torque_gen_old' )
+          READ ( 13 )  torque_gen_old
+
+       CASE DEFAULT
+
+          found = .FALSE.
+
+    END SELECT
+   
+
+ END SUBROUTINE wtm_rrd_global
 
 
@@ -2066,5 +2055,5 @@
                      turb_cl(rseg)  = tl_factor * turb_cl(rseg)                                  
                                  
-                   END IF               
+                   ENDIF               
 !
 !--                !-----------------------------------------------------!
@@ -2371,5 +2360,5 @@
              ENDDO ! End of loop over turbines
                            
-          END IF  ! end of yaw control 
+          ENDIF  ! end of yaw control 
           
           IF ( speed_control )  THEN
Index: palm/trunk/SOURCE/wrd_write_string.f90
===================================================================
--- palm/trunk/SOURCE/wrd_write_string.f90	(revision 2894)
+++ palm/trunk/SOURCE/wrd_write_string.f90	(revision 2894)
@@ -0,0 +1,56 @@
+!> @file user_last_actions.f90
+!------------------------------------------------------------------------------!
+! This file is part of the PALM model system.
+!
+! PALM is free software: you can redistribute it and/or modify it under the
+! terms of the GNU General Public License as published by the Free Software
+! Foundation, either version 3 of the License, or (at your option) any later
+! version.
+!
+! PALM is distributed in the hope that it will be useful, but WITHOUT ANY
+! WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
+! A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
+!
+! You should have received a copy of the GNU General Public License along with
+! PALM. If not, see <http://www.gnu.org/licenses/>.
+!
+! Copyright 1997-2018 Leibniz Universitaet Hannover
+!------------------------------------------------------------------------------!
+!
+! Current revisions:
+! -----------------
+! 
+! 
+! Former revisions:
+! -----------------
+! $Id$
+! Initial revision
+!
+!
+! Description:
+! ------------
+!> Calculates length of string and write the respective value together with the
+!> string into binary file(s) for restart runs
+!------------------------------------------------------------------------------!
+ 
+ SUBROUTINE wrd_write_string( string )
+
+
+    USE kinds
+
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=*), INTENT (IN) ::  string  !< for storing strings in case of writing/reading restart data
+
+    INTEGER(iwp) ::  length  !< integer that specifies the length of a string in case of writing/reading restart
+                             !< data
+
+
+    length = LEN_TRIM( string )
+
+    WRITE ( 14 )  length
+    WRITE ( 14 )  string(1:length)
+
+
+ END SUBROUTINE wrd_write_string
